/***************************************************************************
 *   Copyright (C) 2005 by Tarek Saidi                                     *
 *   tarek.saidi@arcor.de                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _GROUP_VIEW_H_
#define _GROUP_VIEW_H_

#include <QTreeWidget>
#include <QLine>
#include <QContextMenuEvent>
#include "../Kdb3Database.h"

class GroupViewItem;

class KeepassGroupView:public QTreeWidget{
	Q_OBJECT
	public:
		KeepassGroupView(QWidget* parent=0);
		IDatabase *db;
		QList<GroupViewItem*>Items;
		QMenu *ContextMenu;
		QMenu *ContextMenuSearchGroup;
		GroupViewItem* SearchResultItem;
		void createItems();
		void showSearchResults();
		void setCurrentGroup(IGroupHandle* group);
		
	private:
		virtual void dragEnterEvent(QDragEnterEvent* event);
		virtual void dragMoveEvent(QDragMoveEvent* event);
		void entryDragMoveEvent(QDragMoveEvent* event);
		virtual void dragLeaveEvent ( QDragLeaveEvent * event );
		virtual void dropEvent ( QDropEvent * event );
		void entryDropEvent(QDropEvent* event);
		virtual void mousePressEvent(QMouseEvent *event);
		virtual void mouseMoveEvent(QMouseEvent *event);
		virtual void paintEvent ( QPaintEvent * event );
		virtual void contextMenuEvent(QContextMenuEvent *event);	
		void addChilds(GroupViewItem* item);
		QPoint DragStartPos;
		GroupViewItem* DragItem;
		GroupViewItem* LastHoverItem;
		int InsLinePos;
		int InsLineStart;
		enum GroupViewDragType{EntryDrag,GroupDrag};
		GroupViewDragType DragType;
		QList<QTreeWidgetItem*>* EntryDragItems;
	
	public slots:
		void OnCurrentGroupChanged(QTreeWidgetItem*,QTreeWidgetItem*);
		void OnDeleteGroup();
		void OnNewGroup();
		void OnEditGroup();
		void updateIcons();
		void OnHideSearchResults();
		void OnItemExpanded(QTreeWidgetItem*);
		void OnItemCollapsed(QTreeWidgetItem*);
		
	signals:
		void groupChanged(IGroupHandle* NewGroup);
		void searchResultsSelected();
		void fileModified();
		void entriesDropped();
};


class GroupViewItem:public QTreeWidgetItem{
	public:
		GroupViewItem();
		GroupViewItem(QTreeWidget *parent);
		GroupViewItem(QTreeWidget *parent, QTreeWidgetItem * preceding);
		GroupViewItem(QTreeWidgetItem *parent);
		GroupViewItem(QTreeWidgetItem *parent, QTreeWidgetItem * preceding);
		IGroupHandle* GroupHandle;
};



#endif
